# Command Line Parameters

## Usage:

All command line parameters are case-insensitive.
GZBuilder.exe [wadfile] [-map mapname] [-cfg configname] [-delaywindow] [-nosettings] [-strictpatches] [-portable] [-resource wad|dir|pk3 [roottextures] [rootflats] [strictpatches] [notest] resourcename]

## Parameters:

wadfile
This is a .WAD file to load immediately after GZDoom Builder has started up. Unless -map and -cfg are used, this will show the map-options dialog.

-map "mapname"
Where "mapname" is the name of the map (map header lump name) such as MAP01 or E1M1.
When specified, this will indicate the map to load from the specified wad file.
Use in combination with -cfg to provide the required information to skip the map-options dialog.

-delaywindow
This delays showing the main interface window until the automatic map loading from command line parameters is completed, and the program is not terminating yet.
This is usefull for plugins that can be used to perform batch processes where the showing of the main interface window is not desired.
If a plugin completes it's actions on map load and terminates the application immediately, the main window will not be shown at all.

-nosettings
When this parameter is specified, GZDoom Builder will not load your preferences or game configuration settings and will use the default settings instead.
You will not lose your original settings, but when this parameter is specified your settings will not be saved.
-portable - GZDB only.
The editor will be launched in portable mode. It will use the "GZBuilder.cfg" located in the program directory instead of the one located in the "%LocalAppData%\Doom Builder\GZBuilder.cfg" to load and save program settings. Log and crash report files will be also created in the program directory.

## The following parameters are used only when both "wadfile" and "-map" parameters are present

They replicate the settings, which can be set in the Open Map Window.
-strictpatches
Specify this parameter to enforce strictly loading texture patches from between P_START and P_END marker lumps only. This can solve lump name conflicts, but old WAD files do not always adhere to this rule.
-cfg "game_configuration.cfg"
-config "game_configuration.cfg"
The editor will use the specified game configuration file when loading the map.
Do not include the path, all game configurations must be in the "Configurations" subfolder.
-resource <resource type> [flags] "path\to\resource"
Adds a map resource. Note that these are added to the resources, which are automatically loaded according to selected game configuration.
Resource type (required): "wad", "dir" or "pk3".
Flags (optional):

- ROOTTEXTURES - load images in the root directory of the resource as textures (directory/pk3 resources only).
- ROOTFLATS - load images in the root directory of the resource as flats (directory/pk3 resources only).
- STRICTPATCHES - use strict rules for patches (wad resources only).
- NOTEST - exclude this resource from testing parameters.

## Examples:

This loads the file "Ubermegawad.wad" after GZDoom Builder is initialized and shows the map-options dialog:

    GZBuilder.exe "C:\Games\Doom\My Maps\Ubermegawad.wad"

Same as the example above, but now without showing the map-options dialog and instead immediately loading map MAP23 with the Doom 2 game configuration:

    GZBuilder.exe "C:\Games\Doom\My Maps\Ubermegawad.wad" -map MAP23 -cfg "Doom_Doom2Doom.cfg"

Same as the example above, but using one of GZDoom game configurations with added wad file resource and PK3 file resources:

    GZBuilder.exe "C:\Games\Doom\My Maps\Ubermegawad.wad" -map MAP23 -cfg "GZDoom_DoomUDMF.cfg"
                   -resource pk3 notest "C:\GZDoom\gzdoom.pk3"
                   -resource wad strictpatches "C:\Games\Doom\gothtextures.wad"
                   -resource pk3 "C:\Games\Doom\hardmonsters.pk3"